//
// AuthAPIAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Alamofire



public class AuthAPIAPI: APIBase {
    /**
     Получить ключ доступа
     
     - parameter login: (query) Имя пользователя 
     - parameter salt: (query) Соль (см. /auth/start) 
     - parameter response: (query) Вычисленный хэш 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func authLoginPost(login login: String, salt: String, response: String, completion: ((data: String?, error: ErrorType?) -> Void)) {
        authLoginPostWithRequestBuilder(login: login, salt: salt, response: response).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Получить ключ доступа
     - POST /auth/login
     - Возвращает ключ доступа, с которым в дальнейшем будут осуществляться всё взаимодействие с API  (параметр 'token'). Для вычисления значения параметра 'response' необходимо получить представленную в hex MD5-сумму от  объединения строк пароля пользователя, полученной соли и символа переноса строки. Псевдокод операции:  hex(md5(password&nbsp;+&nbsp;salt&nbsp;+&nbsp;'\\n'))
     - examples: [{contentType=application/json, example="aeiou"}]
     
     - parameter login: (query) Имя пользователя 
     - parameter salt: (query) Соль (см. /auth/start) 
     - parameter response: (query) Вычисленный хэш 

     - returns: RequestBuilder<String> 
     */
    public class func authLoginPostWithRequestBuilder(login login: String, salt: String, response: String) -> RequestBuilder<String> {
        let path = "/auth/login"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "login": login,
            "salt": salt,
            "response": response
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<String>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Получить соль
     
     - parameter login: (query) Имя пользователя 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func authStartGet(login login: String, completion: ((data: String?, error: ErrorType?) -> Void)) {
        authStartGetWithRequestBuilder(login: login).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Получить соль
     - GET /auth/start
     - Возвращает соль для авторизации. Это первый этап идентификации пользователя. Затем соль используется  во втором, окончательном этапе авторизации, в запросе /auth/login. Запрос не требует дополнительных параметров.
     - examples: [{contentType=application/json, example="aeiou"}]
     
     - parameter login: (query) Имя пользователя 

     - returns: RequestBuilder<String> 
     */
    public class func authStartGetWithRequestBuilder(login login: String) -> RequestBuilder<String> {
        let path = "/auth/start"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "login": login
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<String>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

}
