//
// DNSAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Alamofire



public class DNSAPI: APIBase {
    /**
     Создание записи домена
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter addDnsZone: (query) зона, которую необходимо создать 
     - parameter addDnsRecord: (query)  (optional)
     - parameter iisSiteForDns: (query) ID сайта из /website/list, либо IP-адрес виртуального сервера, к которому необходимо сделать привязку (optional)
     - parameter bindOnly: (query)  (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func dnsAddGet(token_ token_: String, addDnsZone: String, addDnsRecord: String? = nil, iisSiteForDns: String? = nil, bindOnly: Bool? = nil, completion: ((data: String?, error: ErrorType?) -> Void)) {
        dnsAddGetWithRequestBuilder(token_: token_, addDnsZone: addDnsZone, addDnsRecord: addDnsRecord, iisSiteForDns: iisSiteForDns, bindOnly: bindOnly).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Создание записи домена
     - GET /dns/add
     - examples: [{contentType=application/json, example="aeiou"}]
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter addDnsZone: (query) зона, которую необходимо создать 
     - parameter addDnsRecord: (query)  (optional)
     - parameter iisSiteForDns: (query) ID сайта из /website/list, либо IP-адрес виртуального сервера, к которому необходимо сделать привязку (optional)
     - parameter bindOnly: (query)  (optional)

     - returns: RequestBuilder<String> 
     */
    public class func dnsAddGetWithRequestBuilder(token_ token_: String, addDnsZone: String, addDnsRecord: String? = nil, iisSiteForDns: String? = nil, bindOnly: Bool? = nil) -> RequestBuilder<String> {
        let path = "/dns/add"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_token_": token_,
            "add_dns_zone": addDnsZone,
            "add_dns_record": addDnsRecord,
            "iis_site_for_dns": iisSiteForDns,
            "bind_only": bindOnly
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<String>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Привязка одного домена к другому
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter key_: (query) ID домена из списка /dns/list 
     - parameter bindTo: (query) домен, к которому необходимо сделать привязку (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func dnsBindGet(token_ token_: String, key_: Int32, bindTo: String? = nil, completion: ((data: String?, error: ErrorType?) -> Void)) {
        dnsBindGetWithRequestBuilder(token_: token_, key_: key_, bindTo: bindTo).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Привязка одного домена к другому
     - GET /dns/bind
     - examples: [{contentType=application/json, example="aeiou"}]
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter key_: (query) ID домена из списка /dns/list 
     - parameter bindTo: (query) домен, к которому необходимо сделать привязку (optional)

     - returns: RequestBuilder<String> 
     */
    public class func dnsBindGetWithRequestBuilder(token_ token_: String, key_: Int32, bindTo: String? = nil) -> RequestBuilder<String> {
        let path = "/dns/bind"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_token_": token_,
            "_key_": key_.encodeToJSON(),
            "bind_to": bindTo
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<String>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Получить список доменных имён
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func dnsListGet(token_ token_: String, completion: ((data: [InlineResponse2003]?, error: ErrorType?) -> Void)) {
        dnsListGetWithRequestBuilder(token_: token_).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Получить список доменных имён
     - GET /dns/list
     - examples: [{contentType=application/json, example=[ {
  "full_domain_name_local" : "aeiou",
  "addr1" : "aeiou",
  "zone" : "aeiou",
  "full_domain_name" : "aeiou",
  "online" : true,
  "id" : "",
  "iis_id" : ""
} ]}]
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 

     - returns: RequestBuilder<[InlineResponse2003]> 
     */
    public class func dnsListGetWithRequestBuilder(token_ token_: String) -> RequestBuilder<[InlineResponse2003]> {
        let path = "/dns/list"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_token_": token_
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[InlineResponse2003]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Информация по продлению доменов
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func dnsProlongListGet(token_ token_: String, completion: ((data: [InlineResponse2004]?, error: ErrorType?) -> Void)) {
        dnsProlongListGetWithRequestBuilder(token_: token_).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Информация по продлению доменов
     - GET /dns/prolong/list
     - examples: [{contentType=application/json, example=[ {
  "end_date" : "aeiou",
  "domain_addr" : "aeiou",
  "date_updated" : "aeiou",
  "record_created" : "aeiou",
  "payed_till" : "aeiou",
  "expires_countdown" : "",
  "nservers" : "aeiou",
  "subject_contract" : "aeiou",
  "object_state" : "aeiou"
} ]}]
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 

     - returns: RequestBuilder<[InlineResponse2004]> 
     */
    public class func dnsProlongListGetWithRequestBuilder(token_ token_: String) -> RequestBuilder<[InlineResponse2004]> {
        let path = "/dns/prolong/list"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_token_": token_
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[InlineResponse2004]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Редактирование \"сырой\" зоны
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter key_: (query) ID домена из /dns/list 
     - parameter sDel: (query) Значение &#39;1&#39; сообщает, что запись необходимо удалить 
     - parameter sAdd: (query) Значение &#39;1&#39; сообщает, что запись необходимо создать 
     - parameter dnsType: (query) Тип записи: A, MX, CNAME, AAAA, NS, TXT, SRV 
     - parameter dnsName: (query) Имя записи, либо &#39;@&#39; для корневой 
     - parameter dnsValue: (query) Содержание записи (для A это IP-адрес, для CNAME имя, для MX приоритет и назначение) 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func dnsRawGet(token_ token_: String, key_: Int32, sDel: Int32, sAdd: Int32, dnsType: String, dnsName: String, dnsValue: String, completion: ((data: String?, error: ErrorType?) -> Void)) {
        dnsRawGetWithRequestBuilder(token_: token_, key_: key_, sDel: sDel, sAdd: sAdd, dnsType: dnsType, dnsName: dnsName, dnsValue: dnsValue).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Редактирование \"сырой\" зоны
     - GET /dns/raw
     - examples: [{contentType=application/json, example="aeiou"}]
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter key_: (query) ID домена из /dns/list 
     - parameter sDel: (query) Значение &#39;1&#39; сообщает, что запись необходимо удалить 
     - parameter sAdd: (query) Значение &#39;1&#39; сообщает, что запись необходимо создать 
     - parameter dnsType: (query) Тип записи: A, MX, CNAME, AAAA, NS, TXT, SRV 
     - parameter dnsName: (query) Имя записи, либо &#39;@&#39; для корневой 
     - parameter dnsValue: (query) Содержание записи (для A это IP-адрес, для CNAME имя, для MX приоритет и назначение) 

     - returns: RequestBuilder<String> 
     */
    public class func dnsRawGetWithRequestBuilder(token_ token_: String, key_: Int32, sDel: Int32, sAdd: Int32, dnsType: String, dnsName: String, dnsValue: String) -> RequestBuilder<String> {
        let path = "/dns/raw"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_token_": token_,
            "_key_": key_.encodeToJSON(),
            "s_del": sDel.encodeToJSON(),
            "s_add": sAdd.encodeToJSON(),
            "dns_type": dnsType,
            "dns_name": dnsName,
            "dns_value": dnsValue
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<String>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Редактировать DNS-зону
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter key_: (query) ID домена из /dns/list 
     - parameter managedMx: (query) Значение &#39;1&#39;, если необходимо включить поддержку на MX-серверах хостинга и &#39;0&#39;, если выключить 
     - parameter updManagedMx: (query) Значение &#39;1&#39; подтверждает операцию 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func dnsRawManagedmxGet(token_ token_: String, key_: Int32, managedMx: Int32, updManagedMx: Int32, completion: ((data: String?, error: ErrorType?) -> Void)) {
        dnsRawManagedmxGetWithRequestBuilder(token_: token_, key_: key_, managedMx: managedMx, updManagedMx: updManagedMx).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Редактировать DNS-зону
     - GET /dns/raw/managedmx
     - examples: [{contentType=application/json, example="aeiou"}]
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter key_: (query) ID домена из /dns/list 
     - parameter managedMx: (query) Значение &#39;1&#39;, если необходимо включить поддержку на MX-серверах хостинга и &#39;0&#39;, если выключить 
     - parameter updManagedMx: (query) Значение &#39;1&#39; подтверждает операцию 

     - returns: RequestBuilder<String> 
     */
    public class func dnsRawManagedmxGetWithRequestBuilder(token_ token_: String, key_: Int32, managedMx: Int32, updManagedMx: Int32) -> RequestBuilder<String> {
        let path = "/dns/raw/managedmx"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_token_": token_,
            "_key_": key_.encodeToJSON(),
            "managed_mx": managedMx.encodeToJSON(),
            "upd_managed_mx": updManagedMx.encodeToJSON()
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<String>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

}
