//
// DefaultAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Alamofire



public class DefaultAPI: APIBase {
    /**
     Аккаунт: баланс
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func balanceGet(token_ token_: String, completion: ((data: Double?, error: ErrorType?) -> Void)) {
        balanceGetWithRequestBuilder(token_: token_).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Аккаунт: баланс
     - GET /balance
     - Возвращает текущий баланс аккаунта
     - examples: [{contentType=application/json, example=1.3579000000000001069366817318950779736042022705078125}]
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 

     - returns: RequestBuilder<Double> 
     */
    public class func balanceGetWithRequestBuilder(token_ token_: String) -> RequestBuilder<Double> {
        let path = "/balance"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_token_": token_
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Double>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Аккаунт: баланс аккаунта лицензий
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func balanceLicGet(token_ token_: String, completion: ((data: Double?, error: ErrorType?) -> Void)) {
        balanceLicGetWithRequestBuilder(token_: token_).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Аккаунт: баланс аккаунта лицензий
     - GET /balance.lic
     - Возвращает текущий баланс аккаунта лицензий
     - examples: [{contentType=application/json, example=1.3579000000000001069366817318950779736042022705078125}]
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 

     - returns: RequestBuilder<Double> 
     */
    public class func balanceLicGetWithRequestBuilder(token_ token_: String) -> RequestBuilder<Double> {
        let path = "/balance.lic"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_token_": token_
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Double>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Информация по дебету аккаунта
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func billingDebtGet(token_ token_: String, completion: ((data: [InlineResponse200]?, error: ErrorType?) -> Void)) {
        billingDebtGetWithRequestBuilder(token_: token_).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Информация по дебету аккаунта
     - GET /billing/debt
     - Данный запрос позволяет получить информацию по планируемым датам наступления негативного баланса и отключения
     - examples: [{contentType=application/json, example=[ {
  "last_month_debt_sum2" : 1.3579000000000001069366817318950779736042022705078125,
  "negative_balance_days" : "",
  "last_month_debt_sum" : 1.3579000000000001069366817318950779736042022705078125,
  "block_date" : "aeiou",
  "negative_balance_days_lic" : ""
} ]}]
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 

     - returns: RequestBuilder<[InlineResponse200]> 
     */
    public class func billingDebtGetWithRequestBuilder(token_ token_: String) -> RequestBuilder<[InlineResponse200]> {
        let path = "/billing/debt"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_token_": token_
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[InlineResponse200]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Информация об аккаунте
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func billingInfoGet(token_ token_: String, completion: ((data: [InlineResponse2001]?, error: ErrorType?) -> Void)) {
        billingInfoGetWithRequestBuilder(token_: token_).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Информация об аккаунте
     - GET /billing/info
     - Этот запрос позволяет получить информацию об аккаунте, а также базовую статистику использования ресурсов.
     - examples: [{contentType=application/json, example=[ {
  "stat_tech" : "",
  "stat_nicd" : "",
  "contract_id" : "aeiou",
  "description" : "aeiou",
  "external_currency_spelled_prefix" : "aeiou",
  "client_id" : "",
  "stat_vds_size" : "",
  "client_login" : "aeiou",
  "name_eng" : "aeiou",
  "stat_emails" : "",
  "blocked" : "aeiou",
  "stat_mysqls" : "",
  "credit_limit" : 1.3579000000000001069366817318950779736042022705078125,
  "stat_access_static" : "",
  "__period_price" : 1.3579000000000001069366817318950779736042022705078125,
  "id" : "",
  "external_currency_spelled_suffix" : "aeiou",
  "period_id" : "",
  "email" : "aeiou",
  "name_rus" : "aeiou",
  "stat_sites" : "",
  "blocked_date" : "aeiou",
  "__period_months" : "",
  "__plan_name" : "aeiou",
  "billing_group_id" : "",
  "contract_type" : "",
  "blocked_reason" : "aeiou",
  "stat_access_dynamic" : "",
  "stat_access_traffic" : "",
  "stat_size_mb" : "",
  "stat_paid_total" : "",
  "plan_id" : "",
  "__expires" : "aeiou"
} ]}]
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 

     - returns: RequestBuilder<[InlineResponse2001]> 
     */
    public class func billingInfoGetWithRequestBuilder(token_ token_: String) -> RequestBuilder<[InlineResponse2001]> {
        let path = "/billing/info"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_token_": token_
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[InlineResponse2001]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Получить ограничения аккаунта
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func billingLimitsGet(token_ token_: String, completion: ((data: _?, error: ErrorType?) -> Void)) {
        billingLimitsGetWithRequestBuilder(token_: token_).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Получить ограничения аккаунта
     - GET /billing/limits
     - examples: [{contentType=application/json, example={
  "ftp2" : "aeiou",
  "website" : "aeiou",
  "mail" : "aeiou",
  "size" : "aeiou",
  "mysql" : true,
  "dynamic_content" : true,
  "php_exec" : true,
  "mssql" : true
}}]
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 

     - returns: RequestBuilder<_> 
     */
    public class func billingLimitsGetWithRequestBuilder(token_ token_: String) -> RequestBuilder<_> {
        let path = "/billing/limits"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_token_": token_
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<_>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Информация по продлению доменов
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func dnsProlongListGet(token_ token_: String, completion: ((data: [InlineResponse2004]?, error: ErrorType?) -> Void)) {
        dnsProlongListGetWithRequestBuilder(token_: token_).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Информация по продлению доменов
     - GET /dns/prolong/list
     - examples: [{contentType=application/json, example=[ {
  "end_date" : "aeiou",
  "domain_addr" : "aeiou",
  "date_updated" : "aeiou",
  "record_created" : "aeiou",
  "payed_till" : "aeiou",
  "expires_countdown" : "",
  "nservers" : "aeiou",
  "subject_contract" : "aeiou",
  "object_state" : "aeiou"
} ]}]
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 

     - returns: RequestBuilder<[InlineResponse2004]> 
     */
    public class func dnsProlongListGetWithRequestBuilder(token_ token_: String) -> RequestBuilder<[InlineResponse2004]> {
        let path = "/dns/prolong/list"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_token_": token_
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[InlineResponse2004]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Создание почтового ящика
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter addEmail: (query) Адрес почтового ящика, который необходимо создать 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func emailAddGet(token_ token_: String, addEmail: String, completion: ((data: String?, error: ErrorType?) -> Void)) {
        emailAddGetWithRequestBuilder(token_: token_, addEmail: addEmail).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Создание почтового ящика
     - GET /email/add
     - examples: [{contentType=application/json, example="aeiou"}]
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter addEmail: (query) Адрес почтового ящика, который необходимо создать 

     - returns: RequestBuilder<String> 
     */
    public class func emailAddGetWithRequestBuilder(token_ token_: String, addEmail: String) -> RequestBuilder<String> {
        let path = "/email/add"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_token_": token_,
            "add_email": addEmail
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<String>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Удаление псевдонимов почтовых ящиков
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter key_: (query) Адрес почтового ящика, подлежащего удалению 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func emailAliasDeleteGet(token_ token_: String, key_: String, completion: ((data: String?, error: ErrorType?) -> Void)) {
        emailAliasDeleteGetWithRequestBuilder(token_: token_, key_: key_).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Удаление псевдонимов почтовых ящиков
     - GET /email/alias/delete
     - examples: [{contentType=application/json, example="aeiou"}]
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter key_: (query) Адрес почтового ящика, подлежащего удалению 

     - returns: RequestBuilder<String> 
     */
    public class func emailAliasDeleteGetWithRequestBuilder(token_ token_: String, key_: String) -> RequestBuilder<String> {
        let path = "/email/alias/delete"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_token_": token_,
            "_key_": key_
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<String>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Получить список псевдонимов почтовых ящиков
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func emailAliasListGet(token_ token_: String, completion: ((data: [InlineResponse2005]?, error: ErrorType?) -> Void)) {
        emailAliasListGetWithRequestBuilder(token_: token_).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Получить список псевдонимов почтовых ящиков
     - GET /email/alias/list
     - examples: [{contentType=application/json, example=[ {
  "mail" : "aeiou",
  "alias" : "aeiou",
  "id" : ""
} ]}]
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 

     - returns: RequestBuilder<[InlineResponse2005]> 
     */
    public class func emailAliasListGetWithRequestBuilder(token_ token_: String) -> RequestBuilder<[InlineResponse2005]> {
        let path = "/email/alias/list"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_token_": token_
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[InlineResponse2005]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Удаление почтового ящика
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter key_: (query) Адрес почтового ящика, подлежащего удалению 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func emailDeleteGet(token_ token_: String, key_: String, completion: ((data: String?, error: ErrorType?) -> Void)) {
        emailDeleteGetWithRequestBuilder(token_: token_, key_: key_).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Удаление почтового ящика
     - GET /email/delete
     - examples: [{contentType=application/json, example="aeiou"}]
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter key_: (query) Адрес почтового ящика, подлежащего удалению 

     - returns: RequestBuilder<String> 
     */
    public class func emailDeleteGetWithRequestBuilder(token_ token_: String, key_: String) -> RequestBuilder<String> {
        let path = "/email/delete"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_token_": token_,
            "_key_": key_
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<String>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Получить список почтовых ящиков
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func emailListGet(token_ token_: String, completion: ((data: [InlineResponse2006]?, error: ErrorType?) -> Void)) {
        emailListGetWithRequestBuilder(token_: token_).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Получить список почтовых ящиков
     - GET /email/list
     - examples: [{contentType=application/json, example=[ {
  "archived_count" : "",
  "mail" : "aeiou",
  "server_imap" : "aeiou",
  "mercury_pwd" : "aeiou",
  "size_amount" : "",
  "size_file_count" : "",
  "mercury_user" : "aeiou",
  "online" : true,
  "server_pop3" : "aeiou",
  "server_smtp" : "aeiou",
  "wm1" : "aeiou",
  "id" : "",
  "server_webmail" : "aeiou",
  "wm2" : "aeiou",
  "status" : ""
} ]}]
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 

     - returns: RequestBuilder<[InlineResponse2006]> 
     */
    public class func emailListGetWithRequestBuilder(token_ token_: String) -> RequestBuilder<[InlineResponse2006]> {
        let path = "/email/list"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_token_": token_
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[InlineResponse2006]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Идентификатор последнего уведомления в аудите
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func updatesLastGet(token_ token_: String, completion: ((data: Int32?, error: ErrorType?) -> Void)) {
        updatesLastGetWithRequestBuilder(token_: token_).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Идентификатор последнего уведомления в аудите
     - GET /updates/last
     - examples: [{contentType=application/json, example=""}]
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 

     - returns: RequestBuilder<Int32> 
     */
    public class func updatesLastGetWithRequestBuilder(token_ token_: String) -> RequestBuilder<Int32> {
        let path = "/updates/last"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_token_": token_
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Int32>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Список записей аудита
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter key_: (query) ID первой записи для показа или 0 для показа всех записей 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func updatesListGet(token_ token_: String, key_: Int32, completion: ((data: [InlineResponse20010]?, error: ErrorType?) -> Void)) {
        updatesListGetWithRequestBuilder(token_: token_, key_: key_).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Список записей аудита
     - GET /updates/list
     - examples: [{contentType=application/json, example=[ {
  "datetime" : "aeiou",
  "description_plain" : "aeiou",
  "description" : "aeiou",
  "id" : ""
} ]}]
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter key_: (query) ID первой записи для показа или 0 для показа всех записей 

     - returns: RequestBuilder<[InlineResponse20010]> 
     */
    public class func updatesListGetWithRequestBuilder(token_ token_: String, key_: Int32) -> RequestBuilder<[InlineResponse20010]> {
        let path = "/updates/list"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_token_": token_,
            "_key_": key_.encodeToJSON()
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[InlineResponse20010]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Удаление сайта
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter key_: (query) ID сайта, полученный из /website/list 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func websiteDeleteGet(token_ token_: String, key_: String, completion: ((data: String?, error: ErrorType?) -> Void)) {
        websiteDeleteGetWithRequestBuilder(token_: token_, key_: key_).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Удаление сайта
     - GET /website/delete
     - examples: [{contentType=application/json, example="aeiou"}]
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter key_: (query) ID сайта, полученный из /website/list 

     - returns: RequestBuilder<String> 
     */
    public class func websiteDeleteGetWithRequestBuilder(token_ token_: String, key_: String) -> RequestBuilder<String> {
        let path = "/website/delete"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_token_": token_,
            "_key_": key_
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<String>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Список сайтов аккаунта
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func websiteListGet(token_ token_: String, completion: ((data: [InlineResponse20014]?, error: ErrorType?) -> Void)) {
        websiteListGetWithRequestBuilder(token_: token_).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Список сайтов аккаунта
     - GET /website/list
     - examples: [{contentType=application/json, example=[ {
  "detected_packages" : "aeiou",
  "cpu_limit_exceeded_date" : "aeiou",
  "memo" : "aeiou",
  "sharepoint_mode" : "aeiou",
  "backup_delta_desc" : "aeiou",
  "dns_id" : "aeiou",
  "id" : "",
  "scan_date" : "aeiou",
  "backup_stat_date" : "aeiou",
  "http_frontend_ip_transition" : "aeiou",
  "backup_delta_stat_date" : "aeiou",
  "admin_protection" : "aeiou",
  "cpu_details_enabled" : "aeiou",
  "size_amount" : "aeiou",
  "alt_docroot_server" : "aeiou",
  "backup_delta_date" : "aeiou",
  "alt_docroot_status" : "aeiou",
  "super_backup_date" : "aeiou",
  "user_id" : "aeiou",
  "alt_docroot_path" : "aeiou",
  "feedback_speed_dtc" : "aeiou",
  "analyze_analog" : "aeiou",
  "status" : "aeiou",
  "server_bak" : "aeiou",
  "server" : "aeiou",
  "iis_comments" : "aeiou",
  "apache_generic_pool_port" : "aeiou",
  "block_transfer" : "aeiou",
  "apache_php_pooled_ext_auto" : "aeiou",
  "mail_accept" : "aeiou",
  "size_file_count" : "aeiou",
  "ssh_ipfilter" : "aeiou",
  "live_day_count" : "aeiou",
  "l3d_auto" : "aeiou",
  "flag_no_www" : "aeiou",
  "base_folder" : "aeiou",
  "size_comments" : "aeiou",
  "iis_binding" : "aeiou",
  "apache_php_pool1_only" : "aeiou",
  "iis_creation_commands_unix" : "aeiou",
  "date_reg" : "aeiou",
  "server_transition" : "aeiou",
  "apache_php_pooled" : "aeiou",
  "flag_generic_exec" : "aeiou",
  "aufs_template" : "aeiou",
  "size_check_problem" : "aeiou",
  "net_limit_file" : "aeiou",
  "deleted" : "aeiou",
  "backup_special_mode" : "aeiou",
  "feedback_speed" : "aeiou",
  "global_transfer_count" : "aeiou",
  "copy_logs" : "aeiou",
  "wpb_uuid" : "aeiou",
  "sharepoint_mode_pending" : "aeiou",
  "iis_creation_commands" : "aeiou",
  "smtp_from" : "aeiou",
  "content_comments_verbose" : "aeiou",
  "meta_save_count" : "aeiou",
  "unmovable" : "aeiou",
  "deleted_auto" : "aeiou",
  "bypass_security" : "aeiou",
  "ftp_ipfilter" : "aeiou",
  "thumb_failed" : "aeiou",
  "alt_docroot_status_cnt" : "aeiou",
  "virtualhost_server_conf" : "aeiou",
  "stat_site_power" : "aeiou",
  "net_limit_deny_from_agent" : "aeiou",
  "http_frontend_ip" : "aeiou",
  "content_comments" : "aeiou",
  "iis_id" : "aeiou",
  "wpb_domain" : "aeiou",
  "unix_path_on_windows" : "aeiou",
  "content_moderated_date" : "aeiou",
  "size_date" : "aeiou",
  "server_changed_time" : "aeiou",
  "ftp_id" : "aeiou",
  "backup_date" : "aeiou",
  "options_autolimit" : "aeiou",
  "base_folder_suffix" : "aeiou",
  "size_priority_scan" : "aeiou",
  "apache_php_pool5_only" : "aeiou",
  "apache_ssi" : "aeiou",
  "wpb_status" : "aeiou",
  "server_transition_dtc" : "aeiou",
  "content_moderated_status" : "aeiou",
  "bind_dtc" : "aeiou",
  "size_file_count_limit" : "aeiou",
  "virtualhost_conf" : "aeiou",
  "alt_docroot_status_date" : "aeiou",
  "deleted_dump" : "aeiou",
  "mail_limit" : "aeiou",
  "thumb_date" : "aeiou",
  "ftp_name" : "aeiou",
  "ftp_pwd" : "aeiou",
  "iis_path" : "aeiou",
  "server_aux" : "aeiou",
  "awstats_primary_domain" : "aeiou",
  "feedback_speed_feedback" : "aeiou",
  "alt_docroot_ssd_req" : "aeiou",
  "mail_drop" : "aeiou",
  "flag_free" : "aeiou",
  "mongrel_environment" : "aeiou",
  "virtualhost_server" : "aeiou",
  "net_limit_deny_from_ip" : "aeiou",
  "online" : "aeiou",
  "rtm_scan_date" : "aeiou",
  "apache_php_pooled_ext" : "aeiou"
} ]}]
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 

     - returns: RequestBuilder<[InlineResponse20014]> 
     */
    public class func websiteListGetWithRequestBuilder(token_ token_: String) -> RequestBuilder<[InlineResponse20014]> {
        let path = "/website/list"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_token_": token_
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[InlineResponse20014]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

}
