//
// VDSHyperVOpenVZAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Alamofire



public class VDSHyperVOpenVZAPI: APIBase {
    /**
     Изменение параметров VDS
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter type: (query) Тип создаваемого VDS. &#39;vz1&#39;, &#39;vz2&#39;, &#39;vz3&#39;, &#39;vz4&#39;, &#39;vz5&#39; или &#39;vds.dynamic&#39;. По умолчанию &#39;vds.dynamic&#39; (optional)
     - parameter crHvmem: (query) Количество доступной памяти в мегабайтах. По умолчанию 2048 (optional)
     - parameter crHvdsk: (query) Количество доступных гигабайт диска. По умолчанию 30 (optional)
     - parameter crHvcpu: (query) Количество ядер CPU. По умолчанию 2 (optional)
     - parameter template: (query) Шаблон и тип виртуализации VDS. За подробностями см. /vds/templates-list (optional)
     - parameter forceMemo: (query)  (optional)
     - parameter hv1gbPanelVersion: (query)  (optional)
     - parameter panelInstall: (query) Необходимо ли установить панель 1Gb на VDS (optional)
     - parameter crSsd1: (query) Создать всю систему на SSD (optional)
     - parameter crHvAllSystem: (query) Создать всю систему на одном диске большого размера (иначе — системный диск + диск с данными) (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func vdsCreateGet(token_ token_: String, type: String? = nil, crHvmem: Int32? = nil, crHvdsk: Int32? = nil, crHvcpu: Int32? = nil, template: String? = nil, forceMemo: String? = nil, hv1gbPanelVersion: String? = nil, panelInstall: Bool? = nil, crSsd1: Bool? = nil, crHvAllSystem: Bool? = nil, completion: ((data: String?, error: ErrorType?) -> Void)) {
        vdsCreateGetWithRequestBuilder(token_: token_, type: type, crHvmem: crHvmem, crHvdsk: crHvdsk, crHvcpu: crHvcpu, template: template, forceMemo: forceMemo, hv1gbPanelVersion: hv1gbPanelVersion, panelInstall: panelInstall, crSsd1: crSsd1, crHvAllSystem: crHvAllSystem).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Изменение параметров VDS
     - GET /vds/create
     - Изменение параметров уже существующего VDS
     - examples: [{contentType=application/json, example="aeiou"}]
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter type: (query) Тип создаваемого VDS. &#39;vz1&#39;, &#39;vz2&#39;, &#39;vz3&#39;, &#39;vz4&#39;, &#39;vz5&#39; или &#39;vds.dynamic&#39;. По умолчанию &#39;vds.dynamic&#39; (optional)
     - parameter crHvmem: (query) Количество доступной памяти в мегабайтах. По умолчанию 2048 (optional)
     - parameter crHvdsk: (query) Количество доступных гигабайт диска. По умолчанию 30 (optional)
     - parameter crHvcpu: (query) Количество ядер CPU. По умолчанию 2 (optional)
     - parameter template: (query) Шаблон и тип виртуализации VDS. За подробностями см. /vds/templates-list (optional)
     - parameter forceMemo: (query)  (optional)
     - parameter hv1gbPanelVersion: (query)  (optional)
     - parameter panelInstall: (query) Необходимо ли установить панель 1Gb на VDS (optional)
     - parameter crSsd1: (query) Создать всю систему на SSD (optional)
     - parameter crHvAllSystem: (query) Создать всю систему на одном диске большого размера (иначе — системный диск + диск с данными) (optional)

     - returns: RequestBuilder<String> 
     */
    public class func vdsCreateGetWithRequestBuilder(token_ token_: String, type: String? = nil, crHvmem: Int32? = nil, crHvdsk: Int32? = nil, crHvcpu: Int32? = nil, template: String? = nil, forceMemo: String? = nil, hv1gbPanelVersion: String? = nil, panelInstall: Bool? = nil, crSsd1: Bool? = nil, crHvAllSystem: Bool? = nil) -> RequestBuilder<String> {
        let path = "/vds/create"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_token_": token_,
            "type": type,
            "cr_hvmem": crHvmem?.encodeToJSON(),
            "cr_hvdsk": crHvdsk?.encodeToJSON(),
            "cr_hvcpu": crHvcpu?.encodeToJSON(),
            "template": template,
            "force_memo": forceMemo,
            "hv_1gb_panel_version": hv1gbPanelVersion,
            "panel_install": panelInstall,
            "cr_ssd1": crSsd1,
            "cr_hv_all_system": crHvAllSystem
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<String>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Удаление VDS
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter key_: (query) ID виртуального сервера, полученный из /vds/list 
     - parameter forceCritical: (query) Если true, VDS будет удален срочно (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func vdsDeleteGet(token_ token_: String, key_: Int32, forceCritical: Bool? = nil, completion: ((data: String?, error: ErrorType?) -> Void)) {
        vdsDeleteGetWithRequestBuilder(token_: token_, key_: key_, forceCritical: forceCritical).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Удаление VDS
     - GET /vds/delete
     - Предоставляет функционал для удаления VDS
     - examples: [{contentType=application/json, example="aeiou"}]
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter key_: (query) ID виртуального сервера, полученный из /vds/list 
     - parameter forceCritical: (query) Если true, VDS будет удален срочно (optional)

     - returns: RequestBuilder<String> 
     */
    public class func vdsDeleteGetWithRequestBuilder(token_ token_: String, key_: Int32, forceCritical: Bool? = nil) -> RequestBuilder<String> {
        let path = "/vds/delete"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_token_": token_,
            "_key_": key_.encodeToJSON(),
            "force_critical": forceCritical
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<String>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Добавление IP на VDS
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter key_: (query) ID виртуального сервера, полученный из /vds/list 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func vdsIpAddGet(token_ token_: String, key_: Int32, completion: ((data: String?, error: ErrorType?) -> Void)) {
        vdsIpAddGetWithRequestBuilder(token_: token_, key_: key_).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Добавление IP на VDS
     - GET /vds/ip/add
     - Этот вызов позволяет добавить ещё один IP адрес на указанный VDS
     - examples: [{contentType=application/json, example="aeiou"}]
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter key_: (query) ID виртуального сервера, полученный из /vds/list 

     - returns: RequestBuilder<String> 
     */
    public class func vdsIpAddGetWithRequestBuilder(token_ token_: String, key_: Int32) -> RequestBuilder<String> {
        let path = "/vds/ip/add"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_token_": token_,
            "_key_": key_.encodeToJSON()
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<String>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Удаление IP с VDS
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter key_: (query) ID виртуального сервера, полученный из /vds/list 
     - parameter delIp: (query) IP адрес, который необходимо удалить 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func vdsIpDeleteGet(token_ token_: String, key_: Int32, delIp: String, completion: ((data: String?, error: ErrorType?) -> Void)) {
        vdsIpDeleteGetWithRequestBuilder(token_: token_, key_: key_, delIp: delIp).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Удаление IP с VDS
     - GET /vds/ip/delete
     - Этот вызов позволяет отвязать IP адрес от VDS
     - examples: [{contentType=application/json, example="aeiou"}]
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter key_: (query) ID виртуального сервера, полученный из /vds/list 
     - parameter delIp: (query) IP адрес, который необходимо удалить 

     - returns: RequestBuilder<String> 
     */
    public class func vdsIpDeleteGetWithRequestBuilder(token_ token_: String, key_: Int32, delIp: String) -> RequestBuilder<String> {
        let path = "/vds/ip/delete"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_token_": token_,
            "_key_": key_.encodeToJSON(),
            "del_ip": delIp
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<String>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Список IP-адресов виртуальных серверов
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter key_: (query) ID виртуального сервера, полученный из /vds/list (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func vdsIpListGet(token_ token_: String, key_: Int32? = nil, completion: ((data: [InlineResponse20011]?, error: ErrorType?) -> Void)) {
        vdsIpListGetWithRequestBuilder(token_: token_, key_: key_).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Список IP-адресов виртуальных серверов
     - GET /vds/ip/list
     - Список IP-адресов виртуальных серверов
     - examples: [{contentType=application/json, example=[ {
  "ip" : "aeiou",
  "vds_id" : ""
} ]}]
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter key_: (query) ID виртуального сервера, полученный из /vds/list (optional)

     - returns: RequestBuilder<[InlineResponse20011]> 
     */
    public class func vdsIpListGetWithRequestBuilder(token_ token_: String, key_: Int32? = nil) -> RequestBuilder<[InlineResponse20011]> {
        let path = "/vds/ip/list"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_token_": token_,
            "_key_": key_?.encodeToJSON()
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[InlineResponse20011]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Список виртуальных серверов
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter key_: (query) ID виртуального сервера. Если задан, то будет выдана информация только для этого VDS (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func vdsListGet(token_ token_: String, key_: Int32? = nil, completion: ((data: [InlineResponse20012]?, error: ErrorType?) -> Void)) {
        vdsListGetWithRequestBuilder(token_: token_, key_: key_).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Список виртуальных серверов
     - GET /vds/list
     - Позволяет получить список виртуальных серверов
     - examples: [{contentType=application/json, example=[ {
  "template" : "aeiou",
  "stopped" : true,
  "deleted" : true,
  "online" : true,
  "physical_mac" : "aeiou",
  "type_full" : "aeiou",
  "id" : "",
  "pwd" : "aeiou",
  "type" : "aeiou"
} ]}]
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter key_: (query) ID виртуального сервера. Если задан, то будет выдана информация только для этого VDS (optional)

     - returns: RequestBuilder<[InlineResponse20012]> 
     */
    public class func vdsListGetWithRequestBuilder(token_ token_: String, key_: Int32? = nil) -> RequestBuilder<[InlineResponse20012]> {
        let path = "/vds/list"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_token_": token_,
            "_key_": key_?.encodeToJSON()
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[InlineResponse20012]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Перезагрузка VDS
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter key_: (query) ID виртуального сервера, полученный из /vds/list 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func vdsRebootGet(token_ token_: String, key_: Int32, completion: ((data: String?, error: ErrorType?) -> Void)) {
        vdsRebootGetWithRequestBuilder(token_: token_, key_: key_).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Перезагрузка VDS
     - GET /vds/reboot
     - Предоставляет функционал для перезагрузки VDS
     - examples: [{contentType=application/json, example="aeiou"}]
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter key_: (query) ID виртуального сервера, полученный из /vds/list 

     - returns: RequestBuilder<String> 
     */
    public class func vdsRebootGetWithRequestBuilder(token_ token_: String, key_: Int32) -> RequestBuilder<String> {
        let path = "/vds/reboot"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_token_": token_,
            "_key_": key_.encodeToJSON()
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<String>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Список шаблонов виртуальных серверов
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func vdsTemplatesListGet(token_ token_: String, completion: ((data: [InlineResponse20013]?, error: ErrorType?) -> Void)) {
        vdsTemplatesListGetWithRequestBuilder(token_: token_).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Список шаблонов виртуальных серверов
     - GET /vds/templates-list
     - Позволяет получить список шаблонов виртуальных серверов
     - examples: [{contentType=application/json, example=[ {
  "template" : "aeiou",
  "actual_template" : "",
  "popularity" : "",
  "type" : "aeiou"
} ]}]
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 

     - returns: RequestBuilder<[InlineResponse20013]> 
     */
    public class func vdsTemplatesListGetWithRequestBuilder(token_ token_: String) -> RequestBuilder<[InlineResponse20013]> {
        let path = "/vds/templates-list"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_token_": token_
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[InlineResponse20013]>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Создание VDS
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter key_: (query) ID виртуального сервера, полученный из /vds/list 
     - parameter crHvmem: (query) Количество доступной памяти в мегабайтах. По умолчанию 2048 (optional)
     - parameter crHvdsk: (query) Количество доступных гигабайт диска. По умолчанию 30 (optional)
     - parameter crHvcpu: (query) Количество ядер CPU. По умолчанию 2 (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    public class func vdsUpdateGet(token_ token_: String, key_: Int32, crHvmem: Int32? = nil, crHvdsk: Int32? = nil, crHvcpu: Int32? = nil, completion: ((data: String?, error: ErrorType?) -> Void)) {
        vdsUpdateGetWithRequestBuilder(token_: token_, key_: key_, crHvmem: crHvmem, crHvdsk: crHvdsk, crHvcpu: crHvcpu).execute { (response, error) -> Void in
            completion(data: response?.body, error: error);
        }
    }


    /**
     Создание VDS
     - GET /vds/update
     - Создание новых VDS с произвольными характеристиками
     - examples: [{contentType=application/json, example="aeiou"}]
     
     - parameter token_: (query) Ключ доступа, полученный при авторизации 
     - parameter key_: (query) ID виртуального сервера, полученный из /vds/list 
     - parameter crHvmem: (query) Количество доступной памяти в мегабайтах. По умолчанию 2048 (optional)
     - parameter crHvdsk: (query) Количество доступных гигабайт диска. По умолчанию 30 (optional)
     - parameter crHvcpu: (query) Количество ядер CPU. По умолчанию 2 (optional)

     - returns: RequestBuilder<String> 
     */
    public class func vdsUpdateGetWithRequestBuilder(token_ token_: String, key_: Int32, crHvmem: Int32? = nil, crHvdsk: Int32? = nil, crHvcpu: Int32? = nil) -> RequestBuilder<String> {
        let path = "/vds/update"
        let URLString = SwaggerClientAPI.basePath + path

        let nillableParameters: [String:AnyObject?] = [
            "_token_": token_,
            "_key_": key_.encodeToJSON(),
            "cr_hvmem": crHvmem?.encodeToJSON(),
            "cr_hvdsk": crHvdsk?.encodeToJSON(),
            "cr_hvcpu": crHvcpu?.encodeToJSON()
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<String>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

}
