// Models.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation

protocol JSONEncodable {
    func encodeToJSON() -> AnyObject
}

public class Response<T> {
    public let statusCode: Int
    public let header: [String: String]
    public let body: T

    public init(statusCode: Int, header: [String: String], body: T) {
        self.statusCode = statusCode
        self.header = header
        self.body = body
    }

    public convenience init(response: NSHTTPURLResponse, body: T) {
        let rawHeader = response.allHeaderFields
        var header = [String:String]()
        for (key, value) in rawHeader {
            header[key as! String] = value as? String
        }
        self.init(statusCode: response.statusCode, header: header, body: body)
    }
}

private var once = dispatch_once_t()
class Decoders {
    static private var decoders = Dictionary<String, ((AnyObject) -> AnyObject)>()

    static func addDecoder<T>(clazz clazz: T.Type, decoder: ((AnyObject) -> T)) {
        let key = "\(T.self)"
        decoders[key] = { decoder($0) as! AnyObject }
    }

    static func decode<T>(clazz clazz: [T].Type, source: AnyObject) -> [T] {
        let array = source as! [AnyObject]
        return array.map { Decoders.decode(clazz: T.self, source: $0) }
    }

    static func decode<T, Key: Hashable>(clazz clazz: [Key:T].Type, source: AnyObject) -> [Key:T] {
        let sourceDictionary = source as! [Key: AnyObject]
        var dictionary = [Key:T]()
        for (key, value) in sourceDictionary {
            dictionary[key] = Decoders.decode(clazz: T.self, source: value)
        }
        return dictionary
    }

    static func decode<T>(clazz clazz: T.Type, source: AnyObject) -> T {
        initialize()
        if T.self is Int32.Type && source is NSNumber {
            return source.intValue as! T;
        }
        if T.self is Int64.Type && source is NSNumber {
            return source.longLongValue as! T;
        }
        if source is T {
            return source as! T
        }

        let key = "\(T.self)"
        if let decoder = decoders[key] {
           return decoder(source) as! T
        } else {
            fatalError("Source \(source) is not convertible to type \(clazz): Maybe swagger file is insufficient")
        }
    }

    static func decodeOptional<T>(clazz clazz: T.Type, source: AnyObject?) -> T? {
        if source is NSNull {
            return nil
        }
        return source.map { (source: AnyObject) -> T in
            Decoders.decode(clazz: clazz, source: source)
        }
    }

    static func decodeOptional<T>(clazz clazz: [T].Type, source: AnyObject?) -> [T]? {
        if source is NSNull {
            return nil
        }
        return source.map { (someSource: AnyObject) -> [T] in
            Decoders.decode(clazz: clazz, source: someSource)
        }
    }

    static func decodeOptional<T, Key: Hashable>(clazz clazz: [Key:T].Type, source: AnyObject?) -> [Key:T]? {
        if source is NSNull {
            return nil
        }
        return source.map { (someSource: AnyObject) -> [Key:T] in
            Decoders.decode(clazz: clazz, source: someSource)
        }
    }

    static private func initialize() {
        dispatch_once(&once) {
            let formatters = [
                "yyyy-MM-dd",
                "yyyy-MM-dd'T'HH:mm:ssZZZZZ",
                "yyyy-MM-dd'T'HH:mm:ss.SSSZZZZZ",
                "yyyy-MM-dd'T'HH:mm:ss'Z'",
                "yyyy-MM-dd'T'HH:mm:ss.SSS"
            ].map { (format: String) -> NSDateFormatter in
                let formatter = NSDateFormatter()
                formatter.dateFormat = format
                return formatter
            }
            // Decoder for NSDate
            Decoders.addDecoder(clazz: NSDate.self) { (source: AnyObject) -> NSDate in
               if let sourceString = source as? String {
                    for formatter in formatters {
                        if let date = formatter.dateFromString(sourceString) {
                            return date
                        }
                    }

                }
                if let sourceInt = source as? Int {
                    // treat as a java date
                    return NSDate(timeIntervalSince1970: Double(sourceInt / 1000) )
                }
                fatalError("formatter failed to parse \(source)")
            } 

            // Decoder for [InlineResponse200]
            Decoders.addDecoder(clazz: [InlineResponse200].self) { (source: AnyObject) -> [InlineResponse200] in
                return Decoders.decode(clazz: [InlineResponse200].self, source: source)
            }
            // Decoder for InlineResponse200
            Decoders.addDecoder(clazz: InlineResponse200.self) { (source: AnyObject) -> InlineResponse200 in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = InlineResponse200()
                instance.negativeBalanceDays = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["negative_balance_days"])
                instance.negativeBalanceDaysLic = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["negative_balance_days_lic"])
                instance.lastMonthDebtSum = Decoders.decodeOptional(clazz: Double.self, source: sourceDictionary["last_month_debt_sum"])
                instance.lastMonthDebtSum2 = Decoders.decodeOptional(clazz: Double.self, source: sourceDictionary["last_month_debt_sum2"])
                instance.blockDate = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["block_date"])
                return instance
            }


            // Decoder for [InlineResponse2001]
            Decoders.addDecoder(clazz: [InlineResponse2001].self) { (source: AnyObject) -> [InlineResponse2001] in
                return Decoders.decode(clazz: [InlineResponse2001].self, source: source)
            }
            // Decoder for InlineResponse2001
            Decoders.addDecoder(clazz: InlineResponse2001.self) { (source: AnyObject) -> InlineResponse2001 in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = InlineResponse2001()
                instance.id = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["id"])
                instance.description = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["description"])
                instance.billingGroupId = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["billing_group_id"])
                instance.blocked = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["blocked"])
                instance.blockedDate = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["blocked_date"])
                instance.blockedReason = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["blocked_reason"])
                instance.creditLimit = Decoders.decodeOptional(clazz: Double.self, source: sourceDictionary["credit_limit"])
                instance.planId = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["plan_id"])
                instance.periodId = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["period_id"])
                instance.contractType = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["contract_type"])
                instance.clientId = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["client_id"])
                instance.clientLogin = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["client_login"])
                instance.contractId = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["contract_id"])
                instance.nameRus = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["name_rus"])
                instance.nameEng = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["name_eng"])
                instance.email = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["email"])
                instance.statSites = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["stat_sites"])
                instance.statSizeMb = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["stat_size_mb"])
                instance.statEmails = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["stat_emails"])
                instance.statMysqls = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["stat_mysqls"])
                instance.statTech = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["stat_tech"])
                instance.statNicd = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["stat_nicd"])
                instance.statAccessDynamic = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["stat_access_dynamic"])
                instance.statAccessStatic = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["stat_access_static"])
                instance.statAccessTraffic = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["stat_access_traffic"])
                instance.statPaidTotal = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["stat_paid_total"])
                instance.statVdsSize = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["stat_vds_size"])
                instance.planName = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["__plan_name"])
                instance.periodMonths = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["__period_months"])
                instance.periodPrice = Decoders.decodeOptional(clazz: Double.self, source: sourceDictionary["__period_price"])
                instance.expires = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["__expires"])
                instance.externalCurrencySpelledPrefix = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["external_currency_spelled_prefix"])
                instance.externalCurrencySpelledSuffix = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["external_currency_spelled_suffix"])
                return instance
            }


            // Decoder for [InlineResponse20010]
            Decoders.addDecoder(clazz: [InlineResponse20010].self) { (source: AnyObject) -> [InlineResponse20010] in
                return Decoders.decode(clazz: [InlineResponse20010].self, source: source)
            }
            // Decoder for InlineResponse20010
            Decoders.addDecoder(clazz: InlineResponse20010.self) { (source: AnyObject) -> InlineResponse20010 in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = InlineResponse20010()
                instance.id = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["id"])
                instance.datetime = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["datetime"])
                instance.description = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["description"])
                instance.descriptionPlain = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["description_plain"])
                return instance
            }


            // Decoder for [InlineResponse20011]
            Decoders.addDecoder(clazz: [InlineResponse20011].self) { (source: AnyObject) -> [InlineResponse20011] in
                return Decoders.decode(clazz: [InlineResponse20011].self, source: source)
            }
            // Decoder for InlineResponse20011
            Decoders.addDecoder(clazz: InlineResponse20011.self) { (source: AnyObject) -> InlineResponse20011 in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = InlineResponse20011()
                instance.ip = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["ip"])
                instance.vdsId = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["vds_id"])
                return instance
            }


            // Decoder for [InlineResponse20012]
            Decoders.addDecoder(clazz: [InlineResponse20012].self) { (source: AnyObject) -> [InlineResponse20012] in
                return Decoders.decode(clazz: [InlineResponse20012].self, source: source)
            }
            // Decoder for InlineResponse20012
            Decoders.addDecoder(clazz: InlineResponse20012.self) { (source: AnyObject) -> InlineResponse20012 in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = InlineResponse20012()
                instance.id = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["id"])
                instance.deleted = Decoders.decodeOptional(clazz: Bool.self, source: sourceDictionary["deleted"])
                instance.online = Decoders.decodeOptional(clazz: Bool.self, source: sourceDictionary["online"])
                instance.stopped = Decoders.decodeOptional(clazz: Bool.self, source: sourceDictionary["stopped"])
                instance.pwd = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["pwd"])
                instance.template = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["template"])
                instance.typeFull = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["type_full"])
                instance.physicalMac = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["physical_mac"])
                instance.type = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["type"])
                return instance
            }


            // Decoder for [InlineResponse20013]
            Decoders.addDecoder(clazz: [InlineResponse20013].self) { (source: AnyObject) -> [InlineResponse20013] in
                return Decoders.decode(clazz: [InlineResponse20013].self, source: source)
            }
            // Decoder for InlineResponse20013
            Decoders.addDecoder(clazz: InlineResponse20013.self) { (source: AnyObject) -> InlineResponse20013 in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = InlineResponse20013()
                instance.type = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["type"])
                instance.template = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["template"])
                instance.popularity = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["popularity"])
                instance.actualTemplate = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["actual_template"])
                return instance
            }


            // Decoder for [InlineResponse20014]
            Decoders.addDecoder(clazz: [InlineResponse20014].self) { (source: AnyObject) -> [InlineResponse20014] in
                return Decoders.decode(clazz: [InlineResponse20014].self, source: source)
            }
            // Decoder for InlineResponse20014
            Decoders.addDecoder(clazz: InlineResponse20014.self) { (source: AnyObject) -> InlineResponse20014 in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = InlineResponse20014()
                instance.id = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["id"])
                instance.status = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["status"])
                instance.unmovable = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["unmovable"])
                instance.online = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["online"])
                instance.deleted = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["deleted"])
                instance.deletedAuto = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["deleted_auto"])
                instance.deletedDump = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["deleted_dump"])
                instance.userId = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["user_id"])
                instance.ftpId = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["ftp_id"])
                instance.dnsId = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["dns_id"])
                instance.iisId = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["iis_id"])
                instance.iisBinding = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["iis_binding"])
                instance.iisPath = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["iis_path"])
                instance.iisComments = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["iis_comments"])
                instance.memo = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["memo"])
                instance.dateReg = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["date_reg"])
                instance.server = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["server"])
                instance.serverBak = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["server_bak"])
                instance.serverAux = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["server_aux"])
                instance.serverTransition = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["server_transition"])
                instance.serverTransitionDtc = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["server_transition_dtc"])
                instance.blockTransfer = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["block_transfer"])
                instance.serverChangedTime = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["server_changed_time"])
                instance.sizeAmount = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["size_amount"])
                instance.sizeFileCount = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["size_file_count"])
                instance.sizeFileCountLimit = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["size_file_count_limit"])
                instance.sizeDate = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["size_date"])
                instance.sizePriorityScan = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["size_priority_scan"])
                instance.copyLogs = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["copy_logs"])
                instance.contentComments = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["content_comments"])
                instance.contentCommentsVerbose = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["content_comments_verbose"])
                instance.metaSaveCount = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["meta_save_count"])
                instance.baseFolder = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["base_folder"])
                instance.virtualhostConf = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["virtualhost_conf"])
                instance.virtualhostServer = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["virtualhost_server"])
                instance.virtualhostServerConf = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["virtualhost_server_conf"])
                instance.liveDayCount = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["live_day_count"])
                instance.scanDate = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["scan_date"])
                instance.globalTransferCount = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["global_transfer_count"])
                instance.netLimitFile = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["net_limit_file"])
                instance.netLimitDenyFromIp = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["net_limit_deny_from_ip"])
                instance.netLimitDenyFromAgent = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["net_limit_deny_from_agent"])
                instance.apachePhpPooled = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["apache_php_pooled"])
                instance.apachePhpPooledExt = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["apache_php_pooled_ext"])
                instance.apachePhpPooledExtAuto = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["apache_php_pooled_ext_auto"])
                instance.apachePhpPool1Only = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["apache_php_pool1_only"])
                instance.apachePhpPool5Only = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["apache_php_pool5_only"])
                instance.apacheSsi = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["apache_ssi"])
                instance.bypassSecurity = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["bypass_security"])
                instance.flagGenericExec = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["flag_generic_exec"])
                instance.flagNoWww = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["flag_no_www"])
                instance.baseFolderSuffix = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["base_folder_suffix"])
                instance.feedbackSpeed = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["feedback_speed"])
                instance.feedbackSpeedDtc = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["feedback_speed_dtc"])
                instance.feedbackSpeedFeedback = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["feedback_speed_feedback"])
                instance.unixPathOnWindows = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["unix_path_on_windows"])
                instance.ftpIpfilter = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["ftp_ipfilter"])
                instance.sshIpfilter = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["ssh_ipfilter"])
                instance.l3dAuto = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["l3d_auto"])
                instance.awstatsPrimaryDomain = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["awstats_primary_domain"])
                instance.sharepointMode = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["sharepoint_mode"])
                instance.sharepointModePending = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["sharepoint_mode_pending"])
                instance.apacheGenericPoolPort = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["apache_generic_pool_port"])
                instance.mongrelEnvironment = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["mongrel_environment"])
                instance.flagFree = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["flag_free"])
                instance.rtmScanDate = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["rtm_scan_date"])
                instance.analyzeAnalog = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["analyze_analog"])
                instance.cpuDetailsEnabled = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["cpu_details_enabled"])
                instance.contentModeratedStatus = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["content_moderated_status"])
                instance.contentModeratedDate = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["content_moderated_date"])
                instance.httpFrontendIp = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["http_frontend_ip"])
                instance.httpFrontendIpTransition = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["http_frontend_ip_transition"])
                instance.cpuLimitExceededDate = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["cpu_limit_exceeded_date"])
                instance.aufsTemplate = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["aufs_template"])
                instance.optionsAutolimit = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["options_autolimit"])
                instance.iisCreationCommands = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["iis_creation_commands"])
                instance.iisCreationCommandsUnix = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["iis_creation_commands_unix"])
                instance.thumbDate = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["thumb_date"])
                instance.thumbFailed = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["thumb_failed"])
                instance.backupStatDate = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["backup_stat_date"])
                instance.backupDate = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["backup_date"])
                instance.detectedPackages = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["detected_packages"])
                instance.statSitePower = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["stat_site_power"])
                instance.smtpFrom = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["smtp_from"])
                instance.superBackupDate = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["super_backup_date"])
                instance.backupDeltaStatDate = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["backup_delta_stat_date"])
                instance.backupDeltaDate = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["backup_delta_date"])
                instance.backupDeltaDesc = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["backup_delta_desc"])
                instance.altDocrootServer = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["alt_docroot_server"])
                instance.altDocrootPath = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["alt_docroot_path"])
                instance.altDocrootStatus = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["alt_docroot_status"])
                instance.altDocrootStatusCnt = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["alt_docroot_status_cnt"])
                instance.altDocrootStatusDate = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["alt_docroot_status_date"])
                instance.bindDtc = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["bind_dtc"])
                instance.backupSpecialMode = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["backup_special_mode"])
                instance.sizeCheckProblem = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["size_check_problem"])
                instance.wpbDomain = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["wpb_domain"])
                instance.wpbUuid = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["wpb_uuid"])
                instance.wpbStatus = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["wpb_status"])
                instance.adminProtection = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["admin_protection"])
                instance.sizeComments = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["size_comments"])
                instance.altDocrootSsdReq = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["alt_docroot_ssd_req"])
                instance.mailLimit = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["mail_limit"])
                instance.mailAccept = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["mail_accept"])
                instance.mailDrop = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["mail_drop"])
                instance.ftpName = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["ftp_name"])
                instance.ftpPwd = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["ftp_pwd"])
                return instance
            }


            // Decoder for [InlineResponse2002]
            Decoders.addDecoder(clazz: [InlineResponse2002].self) { (source: AnyObject) -> [InlineResponse2002] in
                return Decoders.decode(clazz: [InlineResponse2002].self, source: source)
            }
            // Decoder for InlineResponse2002
            Decoders.addDecoder(clazz: InlineResponse2002.self) { (source: AnyObject) -> InlineResponse2002 in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = InlineResponse2002()
                instance.id = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["id"])
                instance.name = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["name"])
                instance.server = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["server"])
                instance.pwd = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["pwd"])
                instance.urlSuffix = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["url_suffix"])
                return instance
            }


            // Decoder for [InlineResponse2003]
            Decoders.addDecoder(clazz: [InlineResponse2003].self) { (source: AnyObject) -> [InlineResponse2003] in
                return Decoders.decode(clazz: [InlineResponse2003].self, source: source)
            }
            // Decoder for InlineResponse2003
            Decoders.addDecoder(clazz: InlineResponse2003.self) { (source: AnyObject) -> InlineResponse2003 in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = InlineResponse2003()
                instance.id = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["id"])
                instance.iisId = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["iis_id"])
                instance.online = Decoders.decodeOptional(clazz: Bool.self, source: sourceDictionary["online"])
                instance.fullDomainName = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["full_domain_name"])
                instance.fullDomainNameLocal = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["full_domain_name_local"])
                instance.addr1 = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["addr1"])
                instance.zone = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["zone"])
                return instance
            }


            // Decoder for [InlineResponse2004]
            Decoders.addDecoder(clazz: [InlineResponse2004].self) { (source: AnyObject) -> [InlineResponse2004] in
                return Decoders.decode(clazz: [InlineResponse2004].self, source: source)
            }
            // Decoder for InlineResponse2004
            Decoders.addDecoder(clazz: InlineResponse2004.self) { (source: AnyObject) -> InlineResponse2004 in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = InlineResponse2004()
                instance.dateUpdated = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["date_updated"])
                instance.recordCreated = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["record_created"])
                instance.subjectContract = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["subject_contract"])
                instance.endDate = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["end_date"])
                instance.payedTill = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["payed_till"])
                instance.objectState = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["object_state"])
                instance.domainAddr = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["domain_addr"])
                instance.nservers = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["nservers"])
                instance.expiresCountdown = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["expires_countdown"])
                return instance
            }


            // Decoder for [InlineResponse2005]
            Decoders.addDecoder(clazz: [InlineResponse2005].self) { (source: AnyObject) -> [InlineResponse2005] in
                return Decoders.decode(clazz: [InlineResponse2005].self, source: source)
            }
            // Decoder for InlineResponse2005
            Decoders.addDecoder(clazz: InlineResponse2005.self) { (source: AnyObject) -> InlineResponse2005 in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = InlineResponse2005()
                instance.id = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["id"])
                instance.mail = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["mail"])
                instance.alias = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["alias"])
                return instance
            }


            // Decoder for [InlineResponse2006]
            Decoders.addDecoder(clazz: [InlineResponse2006].self) { (source: AnyObject) -> [InlineResponse2006] in
                return Decoders.decode(clazz: [InlineResponse2006].self, source: source)
            }
            // Decoder for InlineResponse2006
            Decoders.addDecoder(clazz: InlineResponse2006.self) { (source: AnyObject) -> InlineResponse2006 in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = InlineResponse2006()
                instance.id = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["id"])
                instance.status = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["status"])
                instance.online = Decoders.decodeOptional(clazz: Bool.self, source: sourceDictionary["online"])
                instance.mail = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["mail"])
                instance.mercuryUser = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["mercury_user"])
                instance.mercuryPwd = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["mercury_pwd"])
                instance.sizeAmount = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["size_amount"])
                instance.sizeFileCount = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["size_file_count"])
                instance.archivedCount = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["archived_count"])
                instance.serverPop3 = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["server_pop3"])
                instance.serverSmtp = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["server_smtp"])
                instance.serverWebmail = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["server_webmail"])
                instance.serverImap = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["server_imap"])
                instance.wm1 = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["wm1"])
                instance.wm2 = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["wm2"])
                return instance
            }


            // Decoder for [InlineResponse2007]
            Decoders.addDecoder(clazz: [InlineResponse2007].self) { (source: AnyObject) -> [InlineResponse2007] in
                return Decoders.decode(clazz: [InlineResponse2007].self, source: source)
            }
            // Decoder for InlineResponse2007
            Decoders.addDecoder(clazz: InlineResponse2007.self) { (source: AnyObject) -> InlineResponse2007 in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = InlineResponse2007()
                instance.id = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["id"])
                instance.name = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["name"])
                instance.pwd = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["pwd"])
                return instance
            }


            // Decoder for [InlineResponse2008]
            Decoders.addDecoder(clazz: [InlineResponse2008].self) { (source: AnyObject) -> [InlineResponse2008] in
                return Decoders.decode(clazz: [InlineResponse2008].self, source: source)
            }
            // Decoder for InlineResponse2008
            Decoders.addDecoder(clazz: InlineResponse2008.self) { (source: AnyObject) -> InlineResponse2008 in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = InlineResponse2008()
                instance.id = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["id"])
                instance.online = Decoders.decodeOptional(clazz: Bool.self, source: sourceDictionary["online"])
                instance.ftpId = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["ftp_id"])
                instance.dnsId = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["dns_id"])
                instance.sizeAmount = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["size_amount"])
                instance.sizeFileCount = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["size_file_count"])
                instance.sizeFileCountLimit = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["size_file_count_limit"])
                return instance
            }


            // Decoder for [InlineResponse2009]
            Decoders.addDecoder(clazz: [InlineResponse2009].self) { (source: AnyObject) -> [InlineResponse2009] in
                return Decoders.decode(clazz: [InlineResponse2009].self, source: source)
            }
            // Decoder for InlineResponse2009
            Decoders.addDecoder(clazz: InlineResponse2009.self) { (source: AnyObject) -> InlineResponse2009 in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = InlineResponse2009()
                instance.id = Decoders.decodeOptional(clazz: Int32.self, source: sourceDictionary["id"])
                instance.db = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["db"])
                instance.server = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["server"])
                instance.name = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["name"])
                instance.pwd = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["pwd"])
                return instance
            }


            // Decoder for [_]
            Decoders.addDecoder(clazz: [_].self) { (source: AnyObject) -> [_] in
                return Decoders.decode(clazz: [_].self, source: source)
            }
            // Decoder for _
            Decoders.addDecoder(clazz: _.self) { (source: AnyObject) -> _ in
                let sourceDictionary = source as! [NSObject:AnyObject]
                let instance = _()
                instance.mail = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["mail"])
                instance.website = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["website"])
                instance.mysql = Decoders.decodeOptional(clazz: Bool.self, source: sourceDictionary["mysql"])
                instance.size = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["size"])
                instance.mssql = Decoders.decodeOptional(clazz: Bool.self, source: sourceDictionary["mssql"])
                instance.dynamicContent = Decoders.decodeOptional(clazz: Bool.self, source: sourceDictionary["dynamic_content"])
                instance.phpExec = Decoders.decodeOptional(clazz: Bool.self, source: sourceDictionary["php_exec"])
                instance.ftp2 = Decoders.decodeOptional(clazz: String.self, source: sourceDictionary["ftp2"])
                return instance
            }
        }
    }
}
